SystemOrganization addCategory: #WindowBreaker!

Object subclass: #WindowBreaker
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WindowBreaker'!

CircleMorph subclass: #Ball
	instanceVariableNames: 'speed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WindowBreaker'!

!Ball methodsFor: 'stepping' stamp: 'BenjaminVanRyseghem 9/27/2011 03:43'!
checkBorders

	| bottom |
	bottom := TaskbarMorph allInstances first top.
	
	( self top < 0 ) 
		ifTrue: [ 
			self yInvert: 0.
			self top: 0 ].
		
	( self bottom >  bottom)
		ifTrue: [ 
			self yInvert: 0.
			self bottom: bottom ].
		
	( self left < 0 ) 
		ifTrue: [ 
			self xInvert: 0.
			self left: 0 ].
		
	( self right > World right)
		ifTrue: [ 
			self xInvert: 0.
			self right: World right ] ! !

!Ball methodsFor: 'private' stamp: 'BenjaminVanRyseghem 9/27/2011 03:52'!
destroyWindows

	| collision |
	collision := SystemWindow allInstances select: #isDisplayed.
	collision := collision detect: [:each | each fullBounds intersects: self fullBounds ] ifNone: [ ^ self ].

	self top < collision bottom
		ifTrue: [
			self yInvert: 0.
			^ collision delete ].
	self bottom > collision top
		ifTrue: [
			self yInvert: 0.
			^ collision delete].

	self left < collision right
		ifTrue: [
			self xInvert: 0.
			^ collision delete ].
	self right > collision left
		ifTrue: [
			self xInvert: 0.
			^ collision delete ].
! !

!Ball methodsFor: 'private' stamp: 'BenjaminVanRyseghem 9/27/2011 03:06'!
increaseSpeed

	self speed: (self speed x @ (self speed y  + self mg))! !

!Ball methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 9/27/2011 03:42'!
initialize

	super initialize.
	speed := 10*Random new next @ Random new next! !

!Ball methodsFor: 'private' stamp: 'BenjaminVanRyseghem 9/27/2011 03:13'!
mg

	^ 1 * 0.9414! !

!Ball methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/27/2011 03:01'!
speed

	^ speed ifNil: [ speed := 0@0 ].! !

!Ball methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/27/2011 03:01'!
speed: anObject
	
	speed := anObject! !

!Ball methodsFor: 'stepping' stamp: 'BenjaminVanRyseghem 9/27/2011 03:35'!
step
	
"for y:									for x:
	a = m *g								a = 0
	v. = m*g*t + v0							v =  v0
	y =( m*g*t^2)/2 + v0*t+x0				x= v0*t+x0"
			
	self increaseSpeed.		
					
	self top: self top + self speed y.
	self left: self left+ self speed x.
	
	self checkBorders.
	self destroyWindows.! !

!Ball methodsFor: 'stepping' stamp: 'BenjaminVanRyseghem 9/27/2011 03:48'!
stepTime

	^ 1! !

!Ball methodsFor: 'stepping' stamp: 'BenjaminVanRyseghem 9/27/2011 03:16'!
xInvert

	! !

!Ball methodsFor: 'stepping' stamp: 'BenjaminVanRyseghem 9/27/2011 03:40'!
xInvert: acceleration

	self speed: ((self speed x  negated) @ self speed y).! !

!Ball methodsFor: 'stepping' stamp: 'BenjaminVanRyseghem 9/27/2011 03:16'!
yInvert

	self speed: (self speed x @ (self speed y negated)).! !

!Ball methodsFor: 'stepping' stamp: 'BenjaminVanRyseghem 9/27/2011 03:31'!
yInvert: acceleration

	self speed: (self speed x @ (self speed y negated)).! !
